package MT::Plugin::Quickedit;
use strict;

use MT;
use MT::Template::Context;

our $VERSION = "0.1";

@MT::Plugin::Quickedit::ISA = qw(MT::Plugin);

my $plugin = new MT::Plugin::Quickedit({
	name => 'Quickedit',
	version => $VERSION,
	description => 'Jump to Entry Editor.',
	author_name => 'Junnama Noda',
	author_link => 'http://junnama.alfasado.net/online/',
});

MT->add_plugin($plugin);

MT->add_callback('MT::App::CMS::AppTemplateSource.list_blog', 0, $plugin, \&_quickedit);

######################################### Mainroutine #########################################

sub _quickedit {
	my ($eh, $app, $tmpl_ref) = @_;
	my $query = $app->param;
	my $mode = $query->param('quickedit');
	if ($mode == 1) {
		my $permalink = $query->param('permalink');
		my @pathes = split(/\//,$permalink);
		my $counter = @pathes;
		my $lastpth = $pathes[$counter-1];
		my @basenames = split(/\./,$lastpth);
		my $base_len = @basenames;
		my $basename = '';
		my $lastnum = $base_len-1;
		for (my $i = 0; $i < $lastnum; $i++) {
		    $basename .= $basenames[$i];
		    if ($lastnum-1 != $i) {
		    	$basename .= '.';
		    }
		}
		use MT::Entry;
		my $iter = MT::Entry->load_iter({
			basename => $basename},{
			sort => 'modified_on',
			direction => 'descend',
		});
		if (!defined $iter) {
			$iter = MT::Entry->load_iter(
				undef,{
				sort => 'modified_on',
				direction => 'descend',
			});	
		}
		my $match = 0;
		my $blog_id; my $entry_id;
		while (my $entry = $iter->()) {
			if ($entry->permalink eq $permalink){
				$entry_id = $entry->id;
				$blog_id = $entry->blog_id;
				$match = 1;
				last;
			}
		}
		if ($match == 1) {
			my $query_str = $app->uri_params(mode => 'view',
								args => {'_type' => 'entry',
											'id' => $entry_id,
											'blog_id' => $blog_id});
			$app->redirect($app->mt_uri.$query_str);
		} else {
			$app->redirect($app->mt_uri);
		}
	}
}
1;